
Engine.LoadLibrary("rmgen");
Engine.LoadLibrary("rmgen-common");
Engine.LoadLibrary("heightmap");

const Diff=getDifficulty();
// Spawn ships away from the shoreline, but patrol close to the shoreline
const triggerPointShipSpawn = "trigger/trigger_point_A";
const triggerPointShipPatrol = "trigger/trigger_point_B";
const triggerPointShipUnloadLeft = "trigger/trigger_point_C";
const triggerPointShipUnloadRight = "trigger/trigger_point_D";
const triggerPointLandPatrolLeft = "trigger/trigger_point_E";
const triggerPointLandPatrolRight = "trigger/trigger_point_F";
const triggerPointCCAttackerPatrolLeft = "trigger/trigger_point_G";
const triggerPointCCAttackerPatrolRight = "trigger/trigger_point_H";
const triggerPointRiverDirection = "trigger/trigger_point_I";

const oCivicCenter = "structures/maur_civil_centre";
const oBarrack = "structures/maur_barracks";
const oBlacksmith = "structures/maur_blacksmith";
const oFortress = "structures/gaul_fortress";
const oTower = "structures/gaul_defense_tower";
const oOutpost = "structures/gaul_outpost";

const oTemple = "uncapturable|structures/gaul_temple";
const oTavern = "uncapturable|structures/gaul_tavern";
const oHouse ="structures/gaul_house";
const oLongHouse = "uncapturable|other/celt_longhouse";
const oHut = "uncapturable|other/celt_hut";
const oSentryTower = "uncapturable|structures/gaul_sentry_tower";
const oWatchTower = "uncapturable|other/palisades_rocks_watchtower";

const oPalisadeTallSpikes = "uncapturable|other/palisades_tall_spikes";
const oPalisadeAngleSpikes = "uncapturable|other/palisades_angle_spike";
const oPalisadeCurve = "uncapturable|other/palisades_rocks_curve";
const oPalisadeShort = "uncapturable|other/palisades_rocks_short";
const oPalisadeMedium = "uncapturable|other/palisades_rocks_medium";
const oPalisadeLong = "uncapturable|other/palisades_rocks_long";
const oPalisadeGate = "uncapturable|other/palisades_rocks_gate";
const oPalisadePillar = "uncapturable|other/palisades_rocks_tower";

const oFemale = "units/gaul_support_female_citizen";
const oHealer = "units/gaul_support_healer_b";
const oSkirmisher = "units/gaul_infantry_javelinist_b";
const oNakedFanatic = "units/gaul_champion_fanatic";
const smallMapSize = 200;
const mediumMapSize = 250;
const normalMapSize = 320;

function setHeight(pos,h){  if(g_Map.validHeight(pos)){	g_Map.setHeight(pos,h); }  }

const heightLand = 3;
var constr=new HeightConstraint(-Infinity, heightLand);

var g_Map = new RandomMap(2, "grass1_spring");
const numPlayers = getNumPlayers();
const mapCenter = g_Map.getCenter();
const heightDesert = g_Map.getHeight(mapCenter);

const mapBounds = g_Map.getBounds();


var terrain="grass1_spring";
terrain="road_2";
var failFraction=0;
var a=new Vector2D(mapBounds.left, mapBounds.top/2-50);
var a0=new Vector2D(mapBounds.left, mapBounds.top/2-30);
var a1=new Vector2D(mapBounds.left, mapBounds.top/2);
var a2=new Vector2D(mapBounds.left, mapBounds.top/2-10);
var b=new Vector2D(mapBounds.right, mapBounds.top/2-50);
var b0=new Vector2D(mapBounds.right, mapBounds.top/2-30);
var b1=new Vector2D(mapBounds.right, mapBounds.top/2);
var b2=new Vector2D(mapBounds.right, mapBounds.top/2-10);

// Place a gallic village on small maps and larger
var gallicCC = true;
const oWonder = "units/ele_hero";
const oEle = "units/ele_hero";
const riverAngle = 1.65 * Math.PI;
var civicCenterPosition_gaia={"x":20,"y":20,"z":20};
var civicCenterPosition_gaia2={"x":g_Map.getBounds().right-20,"y":20,"z":20};
print ("g_Map.getBounds().right"+g_Map.getBounds().right+"  "+g_Map.getBounds().top);

//var civicCenterPosition_pl={"x":30,"y":g_Map.getBounds().top-30,"z":150};
var civicCenterPosition_pl={"x":28,"y":g_Map.getBounds().top-30,"z":50};
var civicCenterPosition_pl2={"x":g_Map.getBounds().right-30,"y":g_Map.getBounds().top-30,"z":150};
var rightPosition={"x":110,"y":140,"z":200};
var centerPosition={"x":110,"y":100,"z":100};
var centerPosition2={"x":70,"y":30,"z":30};
const gaiaAngle = 0.45 * Math.PI;
var add=40;

var addx_pl=80;
var triggerPointAttacker = "trigger/trigger_point_A";
var triggerPointAttackerB = "trigger/trigger_point_B";
var triggerPointAttackerC = "trigger/trigger_point_C";
var triggerPointAttackerD = "trigger/trigger_point_D";
var triggerPointAttackerI = "trigger/trigger_point_I";
var triggerPointAttackerE = "trigger/trigger_point_E";
var triggerPointAttackerF = "trigger/trigger_point_F";
var triggerPointAttackerG = "trigger/trigger_point_G";
var triggerPointAttackerH = "trigger/trigger_point_H";

var civ = getCivCode(1);
var wall = ["gate", "tower", "long","long",
			"cornerIn", "long", "barracks", "tower", "long", "tower", "house", "long","long","long",
			"cornerIn", "long", "house", "tower", "gate", "tower", "house", "long","long","long",
			"cornerIn", "long", "house", "tower", "long", "tower", "house", "long","long","long",
			"cornerIn", "long","long", "house", "tower"];
	
	
//placeCustomFortress(civicCenterPosition_pl, new Fortress("Spahbod", wall), civ, 1, 0.8);

createArea(
		
	//new RectPlacer(a,b),
	new PathPlacer(a,b, 20, 0.01, 0.99, 0.0, failFraction ),
	[new TerrainPainter("sand_sahara"),  new SmoothElevationPainter(ELEVATION_SET, 10,5,1,3)]
	); 
	
createArea(
	new PathPlacer(a0,b0, 40, 0.1, 0.79, 0.0, failFraction ),
	[new TerrainPainter("road_5"),new SmoothElevationPainter(ELEVATION_SET, 10,5,1,3)],
	null );
createArea(
	new PathPlacer(a1,b1, 40, 0.1, 0.79, 0.0, failFraction ),
	[new TerrainPainter("road1"),new SmoothElevationPainter(ELEVATION_SET, 10,5,1,3)],
	null );
/* createArea(
		
	//new RectPlacer(a,b),
	new PathPlacer(a0,b0, 20, 0.01, 0.99, 0.0, failFraction ),
	[new TerrainPainter("road_5"), new ElevationPainter(6.0)]
	); 
createArea(
		
	//new RectPlacer(a,b),
	new PathPlacer(a2,b2, 20, 0.01, 0.99, 0.0, failFraction ),
	[new TerrainPainter("road1"), new ElevationPainter(9.0)]
	); 
	 */
/* createArea(
		
	new RectPlacer(a1,b1),
	//new PathPlacer(b,a, 0.6, 0.2, 0.5, 0.4, failFraction ),
	[new TerrainPainter("road_5"), new ElevationPainter(10.0)]
	); 
createArea(
		
	new RectPlacer(a2,b2),
	//new PathPlacer(b,a, 0.6, 0.2, 0.5, 0.4, failFraction ),
	[new TerrainPainter("road1"), new ElevationPainter(15.0)]
	);  */

	for (let ik=30;ik< (mapBounds.right-30);ik+=40)
	{
		createArea(
			
		//new RectPlacer(new Vector2D(50, mapBounds.top),new Vector2D(50, mapBounds.bottom)),
		new ClumpPlacer(50, 0.1, 0.7, failFraction , new Vector2D(ik, 180)),
		[new TerrainPainter("dirt_burned"), new SmoothElevationPainter(ELEVATION_MODIFY, 14,5,1,6)]
		); 
	}


/* for (let x = 0; x < (200-1); x++)
{
	for (let z = 0; z < (200-1); z++)
		{
			placeTerrain(new Vector2D(50, 52),new Vector2D(50, 52), new Vector2D(54, 100),new Vector2D(54, 100), terrain);
			//setHeight(x, z, 4);
		}
}  */


function range(size, startAt = 0) {
    return [...Array(size).keys()].map(ik => ik + startAt);
};
var plL=range(numPlayers,0);
print ("plL"+plL);
const mapSize = g_Map.getSize();
var clPlayer = g_Map.createTileClass();
var clHill = g_Map.createTileClass();
var clLand = g_Map.createTileClass();
var clWomen = g_Map.createTileClass();

var clGauls = g_Map.createTileClass();
var clTower = g_Map.createTileClass();
var clOutpost = g_Map.createTileClass();
var clPath = g_Map.createTileClass();

const triggerPointTreasures = [
	"trigger/trigger_point_B",
	"trigger/trigger_point_C",
	"trigger/trigger_point_D"
];
var landConstraint = new StaticConstraint(stayClasses(clLand, 5));
/* for (let triggerPointTreasure of triggerPointTreasures)
	createObjectGroupsDeprecated(
		new SimpleGroup([new SimpleObject(triggerPointTreasure, 1, 1, 0, 0)], true, clWomen),
		0,
		[avoidClasses(clPlayer, 5, clHill, 5), landConstraint],
		scaleByMapSize(40, 140),
		100);
 */




g_Map.placeEntityPassable(triggerPointAttackerF, 1, {"x":4,"y":4}, Math.PI / 2);
g_Map.placeEntityPassable(triggerPointAttackerG, 1, {"x":4,"y":g_Map.getBounds().top-4}, Math.PI / 2);
g_Map.placeEntityPassable(triggerPointAttackerH, 1, {"x":g_Map.getBounds().right-4,"y":4}, Math.PI / 2);
g_Map.placeEntityPassable(triggerPointAttackerI, 1, {"x":g_Map.getBounds().right-4,"y":g_Map.getBounds().top-4}, Math.PI / 2);



g_Map.placeEntityPassable(triggerPointAttacker, 1, {"x":civicCenterPosition_pl.x + 1,"y":civicCenterPosition_pl.y-120}, Math.PI / 2);
g_Map.placeEntityPassable(triggerPointAttackerB, 1, {"x":civicCenterPosition_pl.x -10,"y":civicCenterPosition_pl.y-110}, Math.PI / 2);
g_Map.placeEntityPassable(triggerPointAttackerC, 1, {"x":civicCenterPosition_pl.x + 3,"y":civicCenterPosition_pl.y-195}, Math.PI / 2);
g_Map.placeEntityPassable(triggerPointAttackerD, 1, {"x":civicCenterPosition_pl.x + 20,"y":civicCenterPosition_pl.y-135}, Math.PI / 2);

g_Map.placeEntityPassable(oCivicCenter, 1, civicCenterPosition_pl, riverAngle);
civicCenterPosition_pl.x =civicCenterPosition_pl.x + 10;civicCenterPosition_pl.y-=15
//g_Map.placeEntityPassable(oBarrack, 1, civicCenterPosition_pl, riverAngle);
civicCenterPosition_pl.x =civicCenterPosition_pl.x + 10;civicCenterPosition_pl.y-=15
//g_Map.placeEntityPassable(oBlacksmith, 1, civicCenterPosition_pl, riverAngle);

g_Map.placeEntityPassable(oCivicCenter, 0, civicCenterPosition_gaia2, gaiaAngle);
g_Map.placeEntityPassable(triggerPointAttackerE , 0, {"x":civicCenterPosition_gaia2.x+9,"y":civicCenterPosition_gaia2.y+5}, gaiaAngle);
civicCenterPosition_gaia.x=civicCenterPosition_gaia.x+17;
g_Map.placeEntityPassable(oHouse, 0, civicCenterPosition_gaia, gaiaAngle);

g_Map.placeEntityPassable(oCivicCenter, 0, civicCenterPosition_gaia, gaiaAngle);
g_Map.placeEntityPassable(triggerPointAttackerE , 0, {"x":civicCenterPosition_gaia.x+9,"y":civicCenterPosition_gaia.y+5}, gaiaAngle);


for (let i = 0; i < (numPlayers-1); i++)
	{	
		var j=i+2;
		
		g_Map.placeEntityPassable(oCivicCenter, j, civicCenterPosition_pl2, riverAngle);
		//g_Map.placeEntityPassable(oBarrack, j, {"x":civicCenterPosition_pl2.x + 10,"y":civicCenterPosition_pl2.y-15}, riverAngle);
		//g_Map.placeEntityPassable(oBlacksmith, j, civicCenterPosition_pl, riverAngle);
		//g_Map.placeEntityPassable(oBarrack, 1, {"x":civicCenterPosition_pl2.x + 20,"y":civicCenterPosition_pl2.y-30}, riverAngle);
		g_Map.placeEntityPassable(triggerPointAttacker, j, {"x":civicCenterPosition_pl2.x + 5,"y":civicCenterPosition_pl2.y-120}, gaiaAngle);
		g_Map.placeEntityPassable(triggerPointAttackerB, j, {"x":civicCenterPosition_pl2.x - 20,"y":civicCenterPosition_pl2.y-125},gaiaAngle);
		g_Map.placeEntityPassable(triggerPointAttackerC, j, {"x":civicCenterPosition_pl2.x + 5,"y":civicCenterPosition_pl2.y-165}, gaiaAngle);
		g_Map.placeEntityPassable(triggerPointAttackerD, j, {"x":civicCenterPosition_pl2.x + 20,"y":civicCenterPosition_pl2.y-145}, gaiaAngle);
		g_Map.placeEntityPassable(triggerPointCCAttackerPatrolLeft, j, {"x":civicCenterPosition_pl2.x + 10,"y":civicCenterPosition_pl2.y-15}, gaiaAngle);
		//g_Map.placeEntityPassable(triggerPointAttacker, 1, {"x":120,"y":120}, Math.PI / 2);
		civicCenterPosition_pl2.x-=addx_pl;
		createArea(
			new ClumpPlacer(50, 0.3, 0.3, failFraction , new Vector2D(civicCenterPosition_pl2.x, 160)),
			[new TerrainPainter("dirt_burned"), new ElevationPainter(5.0)]
			);
		print ("civicCenterPosition_pl2  "+civicCenterPosition_pl2.x+ "addx_pl "+addx_pl);
		print ("civicCenterPosition_pl2y  "+civicCenterPosition_pl2.y+ "addx_pl "+addx_pl);
		print ("scaleByMapSize(8, 100)  "+scaleByMapSize(99, 100));
		print ("scaleByMapSize(50, 100)  "+scaleByMapSize(50, 100));
		print ("scaleByMapSize(50, 100)  "+scaleByMapSize(50, 400));
	};
	civicCenterPosition_gaia.y+=10;
	civicCenterPosition_gaia.x+=10;
	var fortress=g_Map.placeEntityPassable(oFortress, 0, civicCenterPosition_gaia, gaiaAngle);
	civicCenterPosition_gaia2.x-=15;
	civicCenterPosition_gaia2.y+=15;
	g_Map.placeEntityPassable(oFortress, 0, civicCenterPosition_gaia2, gaiaAngle);


placePlayersNomad(g_Map.createTileClass());
g_Map.ExportMap();
